%define major 3
%define minor 8
%define fix 0

Name: lapack
Version: %{major}.%{minor}.%{fix}
Release: 1
License: BSD-3-Clause
Summary: LAPACK - Linear Algebra PACKage
Url: http://www.netlib.org/lapack

Source0: http://www.netlib.org/lapack/lapack-%{version}.tar.gz

Source1: static-to-shared.sh

Patch0: lapack-missing-symbol.patch

BuildRequires: gcc-gfortran-aix
BuildRequires: libgfortran3

%description
liblapack is a math libarary.

%package -n liblapack%{major}
Summary: %{summary}
Requires: libblas%{major} = %{version}

%description -n liblapack%{major}
liblapack is a math libarary.

%package -n liblapacke%{major}
Summary: The C language interface to LAPACK
Requires: liblapack%{major} = %{version}

%description -n liblapacke%{major}
The C language interface to LAPACK

%package -n libblas%{major}
Summary: Basic Linear Algebra Subprograms

%description -n libblas%{major}
The BLAS (Basic Linear Algebra Subprograms) are routines that provide standard
building blocks for performing basic vector and matrix operations.

%package -n libcblas%{major}
Summary: The C language interface of BLAS
Requires: libblas%{major} = %{version}

%description -n libcblas%{major}
The C language interface of BLAS


%package devel
Summary: LAPACK development files
Requires: liblapack%{major} = %{version}

%description devel
LAPACK development files

%package -n lapacke-devel
Summary: LAPACKE development files
Requires: liblapacke%{major} = %{version}

%description -n lapacke-devel
LAPACKE development files

%package -n blas-devel
Summary: BLAS development files
Requires: libblas%{major} = %{version}

%description -n blas-devel
BLAS development files

%package -n cblas-devel
Summary: CBLAS development files
Requires: libcblas%{major} = %{version}

%description -n cblas-devel
CBLAS development files


%prep
%setup -q -n lapack-%{version}

%patch0 -p1

%build
cp make.inc.example make.inc

CFLAGS="-O3 -fPIC"
OPTS="-O2 -frecursive -fPIC"
NOOPT=$OPTS
LOADOPTS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib"

# Build BLAS
%make_build blaslib CFLAGS="$CFLAGS" OPTS="$OPTS" NOOPT="$NOOPT" LOADOPTS="$LOADOPTS"
CC=gfortran %{SOURCE1} libblas.so.%{major} librefblas.a $LOADOPTS

# Build CBLAS
%make_build cblaslib CFLAGS="$CFLAGS" OPTS="$OPTS" NOOPT="$NOOPT" LOADOPTS="$LOADOPTS"
CC=gfortran %{SOURCE1} libcblas.so.%{major} libcblas.a ./libblas.so.%{major} $LOADOPTS

# Build LAPACK
%make_build lapacklib CFLAGS="$CFLAGS" OPTS="$OPTS" NOOPT="$NOOPT" LOADOPTS="$LOADOPTS"
CC=gfortran %{SOURCE1} liblapack.so.%{major} liblapack.a ./libblas.so.%{major} $LOADOPTS

# Build LAPACKE
%make_build lapackelib CFLAGS="$CFLAGS" OPTS="$OPTS" NOOPT="$NOOPT" LOADOPTS="$LOADOPTS"
CC=gfortran %{SOURCE1} liblapacke.so.%{major} liblapacke.a ./liblapack.so.%{major} $LOADOPTS

%check
make blas_testing
make cblas_testing

ln -s $(which python2) python
PATH=$PWD:$PATH
make lapack_testing

%install
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}


cp CBLAS/include/*.h %{buildroot}%{_includedir}
cp LAPACKE/include/*.h %{buildroot}%{_includedir}

cp *.so.%{major} %{buildroot}%{_libdir}

ln -s libblas.so.%{major} %{buildroot}%{_libdir}/libblas.so
ln -s libcblas.so.%{major} %{buildroot}%{_libdir}/libcblas.so
ln -s liblapack.so.%{major} %{buildroot}%{_libdir}/liblapack.so
ln -s liblapacke.so.%{major} %{buildroot}%{_libdir}/liblapacke.so


%files -n liblapack%{major}
%defattr(-, qsys, *none)

%{_libdir}/liblapack.so.%{major}


%files devel
%defattr(-, qsys, *none)

%{_libdir}/liblapack.so


%files -n liblapacke%{major}
%defattr(-, qsys, *none)

%{_libdir}/liblapacke.so.%{major}


%files -n lapacke-devel
%defattr(-, qsys, *none)

%{_includedir}/lapacke*

%{_libdir}/liblapacke.so


%files -n libblas%{major}
%defattr(-, qsys, *none)

%{_libdir}/libblas.so.%{major}


%files -n blas-devel
%defattr(-, qsys, *none)

%{_libdir}/libblas.so


%files -n libcblas%{major}
%defattr(-, qsys, *none)

%{_libdir}/libcblas.so.%{major}


%files -n cblas-devel
%defattr(-, qsys, *none)

%{_includedir}/cblas*

%{_libdir}/libcblas.so


%changelog
* Thu Nov 28 2019 Kevin Adler <kadler@us.ibm.com> - 3.8.0
- Use SPDX license identifier

* Thu Jan 17 2019 - Xu Meng <mengxumx@cn.ibm.com>
- Build shared libraries instead of static libraries
- Build BLAS libraries from this package, too
- Update to version 3.8.0

* Mon Jun 25 2018 - mengxumx <mengxumx@cn.ibm.com>
- Initial package
